#!/bin/bash
# /var/www/html/ztp_oob.sh

function error() {
  echo -e "\e[0;33mERROR: The Zero Touch Provisioning script failed while running the command $BASH_COMMAND at line $BASH_LINENO.\e[0m" >&2
}

# Log all output from this script
exec >> /var/log/autoprovision 2>&1
date "+%FT%T ztp starting script $0"

trap error ERR

# Create the user to be used by automation
useradd -m {{ oob_deploy_user }}
usermod --shell /bin/bash {{ oob_deploy_user }}

# Setup the Pre-shared SSH Key
mkdir -p /home/{{ oob_deploy_user }}/.ssh
wget -O /home/{{ oob_deploy_user }}/.ssh/authorized_keys http://{{ oob_server }}/authorized_keys

# Make sure the SSH key is stored with the correct settings
chown -Rv {{ oob_deploy_user }}:{{ oob_deploy_user }} /home/{{ oob_deploy_user }}/
chmod 600 /home/{{ oob_deploy_user }}/.ssh/*

# Add automation user to important groups
usermod -a -G sudo,netedit,netshow {{ oob_deploy_user }}

# Give sudo Powahr to mgmt user
echo "{{ oob_deploy_user }} ALL=(ALL) NOPASSWD:ALL" > /etc/sudoers.d/10_{{ oob_deploy_user }}

# Install the license
/usr/cumulus/bin/cl-license -i http://{{ oob_server }}/license

# Restart switchd to load license
/bin/systemctl restart switchd.service

# Set Management VRF
sed -i '/iface eth0/a \ vrf mgmt' /etc/network/interfaces
cat <<EOT >> /etc/network/interfaces
auto mgmt
iface mgmt
  address 127.0.0.1/8
  address ::1/128
  vrf-table auto
EOT

# Reload interfaces to apply loaded config
ifreload -a

echo "$(date) INFO: ZTP IS FINISHED!"

# Create handover file
touch /tmp/ztpfinished

#CUMULUS-AUTOPROVISIONING
exit 0
